unit DemoMain;

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, DSAMsg;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    MsgText: TMemo;
    Label2: TLabel;
    MsgType: TComboBox;
    GroupBox1: TGroupBox;
    Yes: TCheckBox;
    No: TCheckBox;
    Ok: TCheckBox;
    Cancel: TCheckBox;
    Abort: TCheckBox;
    Retry: TCheckBox;
    Ignore: TCheckBox;
    Help: TCheckBox;
    Test: TButton;
    Clear: TButton;
    Custom: TButton;
    Bevel2: TBevel;
    ClearCustom: TButton;
    Form: TButton;
    FormClear: TButton;
    Bevel1: TBevel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure TestClick(Sender: TObject);
    procedure ClearClick(Sender: TObject);
    procedure CustomClick(Sender: TObject);
    procedure ClearCustomClick(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure FormClearClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  TypInfo, CustDlg, DSADlg;

procedure TForm1.FormCreate(Sender: TObject);
var
  x: TMsgDlgType;
begin
  for x := Low(TMsgDlgType) to High(TMsgDlgType) do
    {$IFDEF WIN32}
    MsgType.Items.Add(GetEnumName(TypeInfo(TMsgDlgType), ord(x)));
    {$ELSE}
    MsgType.Items.Add(GetEnumName(TypeInfo(TMsgDlgType), ord(x))^);
    {$ENDIF}
  MsgType.ItemIndex := 0;
  {$IFNDEF WIN32}
  MsgText.MaxLength := 255;
  {$ENDIF}
end;

{$IFDEF VER80}
function GetListAsString(List: TStrings): string;
var
  I, L, Size, Count: Integer;
  P: PChar;
  S: string;
begin
  Result := '';
  Count := List.Count;
  Size := 0;
  for I := 0 to Count - 1 do
  begin
    Result := Result + List[I] + #13#10;
  end;
end;
{$ENDIF}

procedure TForm1.TestClick(Sender: TObject);
var
  Btns: TMsgDlgButtons;
begin
  Btns := [];
  if Yes.Checked then
    Include(Btns, mbYes);
  if No.Checked then
    Include(Btns, mbNo);
  if OK.Checked then
    Include(Btns, mbOK);
  if Cancel.Checked then
    Include(Btns, mbCancel);
  if Abort.Checked then
    Include(Btns, mbAbort);
  if Retry.Checked then
    Include(Btns, mbRetry);
  if Ignore.Checked then
    Include(Btns, mbIgnore);
  if Help.Checked then
    Include(Btns, mbHelp);
{$IFDEF VER80}
  DSAMessageDlg(GetListAsString(MsgText.Lines),
     { Normally, you'd just use something like mtInformation for this param }
     TMsgDlgType(GetEnumValue(TypeInfo(TMsgDlgType), MsgType.Items[MsgType.ItemIndex])),
     Btns, 0, mrOK);
{$ELSE}
  DSAMessageDlg(MsgText.Lines.Text,
     { Normally, you'd just use something like mtInformation for this param }
     TMsgDlgType(GetEnumValue(TypeInfo(TMsgDlgType), MsgType.Items[MsgType.ItemIndex])),
     Btns, 0, mrOK);
{$ENDIF}
end;

procedure TForm1.ClearClick(Sender: TObject);
begin
{$IFDEF VER80}
  DSAClear(GetListAsString(MsgText.Lines));
{$ELSE}
  DSAClear(MsgText.Lines.Text);
{$ENDIF}
end;

procedure TForm1.CustomClick(Sender: TObject);
var
  Dlg: TDSACustomDlg;
begin
  Dlg := TDSACustomDlg.Create(Self);
  try
    DSAShowModal(Dlg, mrAbort);
  finally
    Dlg.Free;
  end;
end;


procedure TForm1.ClearCustomClick(Sender: TObject);
begin
  DSAFormClear(TDSACustomDlg);
end;

procedure TForm1.FormClick(Sender: TObject);
var
  Dlg: TDSATestForm;
begin
  Dlg := TDSATestForm.Create(Self);
  Dlg.DSAShow;
end;

procedure TForm1.FormClearClick(Sender: TObject);
var
  Dlg: TDSATestForm;
begin
  Dlg := TDSATestForm.Create(Self);
  Dlg.DSAClear;
  Dlg.Free;
end;


end.


